routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();


Route::middleware('auth')->group(function () {
    $this->any('/', function () {
        return view('index');
    })->name('index');


    Route::prefix('users')->name('users.')->group(function () {
        $this->any('/create', 'UserController@create')->name('create');
    });

    Route::prefix('subjects')->name('subjects.')->group(function () {
        $this->get('/', 'SubjectController@view')->name('index');
        $this->any('/create', 'SubjectController@create')->name('create');
        $this->any('/{subject}', 'SubjectController@update')->name('update');
        $this->any('/delete/{subject}', 'SubjectController@delete')->name('delete');
    });

    Route::prefix('faculties')->name('faculties.')->group(function () {
        $this->get('/', 'GroupController@view')->name('index');
        $this->get('/{id}', 'GroupController@directions')->name('direction');
        $this->get('/direction/{id}', 'GroupController@groups')->name('group');
        $this->get('/direction/group/{id}', 'GroupController@students')->name('student');
    });

    Route::prefix('plans')->name('plans.')->group(function () {
        $this->get('/', 'PlanController@semesters')->name('semesters');
        $this->get('/{semester}', 'PlanController@semester')->name('semester');
        $this->any('/{semester}/{group}', 'PlanController@group')->name('group');
    });
    Route::prefix('schedule')->name('schedule.')->group(function () {
        $this->get('/', 'LessonController@index')->name('index');
        $this->any('/{group}', 'LessonController@group')->name('group');
        $this->any('/prevWeek/{group}', 'LessonController@prevWeek')->name('prevWeek');
        $this->any('/add/{group}/{pair}/{day}', 'LessonController@add')->name('add');
        $this->any('/update/{lesson}/{day}', 'LessonController@update')->name('update');
    });

    Route::prefix('knowledge')->name('knowledge.')->group(function () {
        $this->get('/', 'KnowledgeController@index')->name('index');
        $this->post('/add', 'KnowledgeController@add')->name('add');
    });

});

app/Group.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Group extends Model {
    protected $guarded = ['id'];

    public function direction () {
        $this->belongsTo('App\Direction');
    }

    public function subjects () {
        $query = $this->belongsToMany(Subject::class, 'groups2subjects2semesters');

        if(isset($this->pivot)) {
            $query = $query->where(function ($q) {
                $q->where('groups2subjects2semesters.semester_id', $this->pivot->semester_id);
            });
        }

        return $query;
    }

    public function semesters () {
        $query = $this->belongsToMany(Semester::class, 'groups2subjects2semesters');

        if(isset($this->pivot)) {
            $query = $query->where(function ($q) {
                $q->where('groups2subjects2semesters.subject_id', $this->pivot->subject_id);
            });
        }

        return $query;
    }

    public function lessons () {
        $this->hasMany(Lesson::class);
    }
}

app/Http/Controllers/GroupController.php
<?php

namespace App\Http\Controllers;

use App\Faculty;
use App\Group;
use App\Direction;
use App\Student;
use Illuminate\Http\Request;

class GroupController extends Controller
{
    public function view() {
        $faculties = Faculty::all();

        return view('groups.index', compact(['faculties']));
    }

    public function directions($id) {
        $faculty = Faculty::find($id);

        $directions = Direction::where('faculty_id', $faculty->id)->get();

        return view('groups.direction', compact(['directions']));
    }

    public function groups($id) {
        $direction = Direction::find($id);

        $groups = Group::where('direction_id', $direction->id)->get();

        return view('groups.group', compact(['groups']));
    }


    public function students($id) {
        $group = Group::find($id);

        $students = Student::where('group', $group->name)->get();

        return view('groups.student', compact(['group', 'students']));
    }
}

resources/views/groups/direction.blade.php
@extends ('layouts.app')

@section ('content')

    <div class="container">
        <h2>Список направлений</h2>
        <div class="row">
            @foreach($directions as $direction)
                <div class="col-3" class="border">
                    <a href="{{ route('faculties.group', ['id' => $direction->id]) }}">Направление: {{ $direction->name }}</a>
                </div>
            @endforeach
        </div>
    </div>

@endsection

resources/views/groups/group.blade.php
@extends ('layouts.app')

@section ('content')

    <div class="container">
        <h2>Список групп</h2>
        <div class="row">
            @foreach($groups as $group)
                <div class="col-3" class="border">
                    <a href="{{ route('faculties.student', ['id' => $group->id]) }}">Группа: {{ $group->name }}</a>
                </div>
            @endforeach
        </div>
    </div>

@endsection

resources/views/groups/index.blade.php
@extends ('layouts.app')

@section ('content')

    <div class="container">
        <h2>Список факультетов</h2>
        <div class="row">
            @foreach($faculties as $faculty)
                <div class="col-3" class="border">
                    <a href="{{ route('faculties.direction', ['id' => $faculty->id]) }}">Факультет: {{ $faculty->name }}</a>
                </div>
            @endforeach
        </div>
    </div>

@endsection

resources/views/groups/student.blade.php
@extends ('layouts.app')

@section('content')

    <div class="container">
        <h2>
            {{ $group->name }}
        </h2>
        <h3>Список сутдентов:</h3>
            <table class="table">
                <thead>
                <tr>
                    <th>Фамилия</th>
                    <th>Имя</th>
                    <th>Отчество(если есть)</th>
                    <th>Шифр</th>
                </tr>
                </thead>
                <tbody>
                @foreach ($students as $student)
                    <tr>
                    <td>{{ $student->second_name }}</td>
                    <td>{{ $student->first_name }}</td>
                    <td>{{ $student->middle_name }}</td>
                    <td>{{ $student->cipher }}</td>
                    </tr>
                @endforeach
                </tbody>
            </table>
        <p>

            </p>
    </div>

@endsection